/* Generated by wayland-scanner 1.21.0 */

#ifndef TEXT_INPUT_EXTENSION_UNSTABLE_V1_CLIENT_PROTOCOL_H
#define TEXT_INPUT_EXTENSION_UNSTABLE_V1_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_text_input_extension_unstable_v1 The text_input_extension_unstable_v1 protocol
 * @section page_ifaces_text_input_extension_unstable_v1 Interfaces
 * - @subpage page_iface_zcr_text_input_extension_v1 - extends text_input to support richer operations
 * - @subpage page_iface_zcr_extended_text_input_v1 - extension of text_input protocol
 * @section page_copyright_text_input_extension_unstable_v1 Copyright
 * <pre>
 *
 * Copyright 2021 The Chromium Authors
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 * </pre>
 */
struct zcr_extended_text_input_v1;
struct zcr_text_input_extension_v1;
struct zwp_text_input_v1;

#ifndef ZCR_TEXT_INPUT_EXTENSION_V1_INTERFACE
#define ZCR_TEXT_INPUT_EXTENSION_V1_INTERFACE
/**
 * @page page_iface_zcr_text_input_extension_v1 zcr_text_input_extension_v1
 * @section page_iface_zcr_text_input_extension_v1_desc Description
 *
 * Allows a text_input to sends more variation of operations to support
 * richer features, such as set_preedit_region.
 *
 * Warning! The protocol described in this file is experimental and
 * backward incompatible changes may be made. Backward compatible changes
 * may be added together with the corresponding uinterface version bump.
 * Backward incompatible changes are done by bumping the version number in
 * the protocol and interface names and resetting the interface version.
 * Once the protocol is to be declared stable, the 'z' prefix and the
 * version number in the protocol and interface names are removed and the
 * interface version number is reset.
 * @section page_iface_zcr_text_input_extension_v1_api API
 * See @ref iface_zcr_text_input_extension_v1.
 */
/**
 * @defgroup iface_zcr_text_input_extension_v1 The zcr_text_input_extension_v1 interface
 *
 * Allows a text_input to sends more variation of operations to support
 * richer features, such as set_preedit_region.
 *
 * Warning! The protocol described in this file is experimental and
 * backward incompatible changes may be made. Backward compatible changes
 * may be added together with the corresponding uinterface version bump.
 * Backward incompatible changes are done by bumping the version number in
 * the protocol and interface names and resetting the interface version.
 * Once the protocol is to be declared stable, the 'z' prefix and the
 * version number in the protocol and interface names are removed and the
 * interface version number is reset.
 */
extern const struct wl_interface zcr_text_input_extension_v1_interface;
#endif
#ifndef ZCR_EXTENDED_TEXT_INPUT_V1_INTERFACE
#define ZCR_EXTENDED_TEXT_INPUT_V1_INTERFACE
/**
 * @page page_iface_zcr_extended_text_input_v1 zcr_extended_text_input_v1
 * @section page_iface_zcr_extended_text_input_v1_desc Description
 *
 * The zcr_extended_text_input_v1 interface extends the text_input interface
 * to support more rich operations on text_input.
 * @section page_iface_zcr_extended_text_input_v1_api API
 * See @ref iface_zcr_extended_text_input_v1.
 */
/**
 * @defgroup iface_zcr_extended_text_input_v1 The zcr_extended_text_input_v1 interface
 *
 * The zcr_extended_text_input_v1 interface extends the text_input interface
 * to support more rich operations on text_input.
 */
extern const struct wl_interface zcr_extended_text_input_v1_interface;
#endif

#ifndef ZCR_TEXT_INPUT_EXTENSION_V1_ERROR_ENUM
#define ZCR_TEXT_INPUT_EXTENSION_V1_ERROR_ENUM
enum zcr_text_input_extension_v1_error {
	/**
	 * the text_input already has an extended_text_input object associated
	 */
	ZCR_TEXT_INPUT_EXTENSION_V1_ERROR_EXTENDED_TEXT_INPUT_EXISTS = 0,
};
#endif /* ZCR_TEXT_INPUT_EXTENSION_V1_ERROR_ENUM */

#define ZCR_TEXT_INPUT_EXTENSION_V1_GET_EXTENDED_TEXT_INPUT 0


/**
 * @ingroup iface_zcr_text_input_extension_v1
 */
#define ZCR_TEXT_INPUT_EXTENSION_V1_GET_EXTENDED_TEXT_INPUT_SINCE_VERSION 1

/** @ingroup iface_zcr_text_input_extension_v1 */
static inline void
zcr_text_input_extension_v1_set_user_data(struct zcr_text_input_extension_v1 *zcr_text_input_extension_v1, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zcr_text_input_extension_v1, user_data);
}

/** @ingroup iface_zcr_text_input_extension_v1 */
static inline void *
zcr_text_input_extension_v1_get_user_data(struct zcr_text_input_extension_v1 *zcr_text_input_extension_v1)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zcr_text_input_extension_v1);
}

static inline uint32_t
zcr_text_input_extension_v1_get_version(struct zcr_text_input_extension_v1 *zcr_text_input_extension_v1)
{
	return wl_proxy_get_version((struct wl_proxy *) zcr_text_input_extension_v1);
}

/** @ingroup iface_zcr_text_input_extension_v1 */
static inline void
zcr_text_input_extension_v1_destroy(struct zcr_text_input_extension_v1 *zcr_text_input_extension_v1)
{
	wl_proxy_destroy((struct wl_proxy *) zcr_text_input_extension_v1);
}

/**
 * @ingroup iface_zcr_text_input_extension_v1
 *
 * Create extended_text_input object.
 * See zcr_extended_text_input interface for details.
 * If the given text_input object already has a extended_text_input object
 * associated, the extended_text_input_exists protocol error is raised.
 */
static inline struct zcr_extended_text_input_v1 *
zcr_text_input_extension_v1_get_extended_text_input(struct zcr_text_input_extension_v1 *zcr_text_input_extension_v1, struct zwp_text_input_v1 *text_input)
{
	struct wl_proxy *id;

	id = wl_proxy_marshal_flags((struct wl_proxy *) zcr_text_input_extension_v1,
			 ZCR_TEXT_INPUT_EXTENSION_V1_GET_EXTENDED_TEXT_INPUT, &zcr_extended_text_input_v1_interface, wl_proxy_get_version((struct wl_proxy *) zcr_text_input_extension_v1), 0, NULL, text_input);

	return (struct zcr_extended_text_input_v1 *) id;
}

#ifndef ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_TYPE_ENUM
#define ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_TYPE_ENUM
/**
 * @ingroup iface_zcr_extended_text_input_v1
 * Chrome's TextInputType
 *
 * Wayland has its own input-type support, which is
 * zwp_text_input::content_purpose. However, it is not rich enough to
 * represent all Chrome's input types. This enum is introduced to keep
 * all entries so exo can understand it without any information loss.
 * See TextInputType's description for details about each entry.
 */
enum zcr_extended_text_input_v1_input_type {
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_TYPE_NONE = 0,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_TYPE_TEXT = 1,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_TYPE_PASSWORD = 2,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_TYPE_SEARCH = 3,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_TYPE_EMAIL = 4,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_TYPE_NUMBER = 5,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_TYPE_TELEPHONE = 6,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_TYPE_URL = 7,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_TYPE_DATE = 8,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_TYPE_DATE_TIME = 9,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_TYPE_DATE_TIME_LOCAL = 10,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_TYPE_MONTH = 11,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_TYPE_TIME = 12,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_TYPE_WEEK = 13,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_TYPE_TEXT_AREA = 14,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_TYPE_CONTENT_EDITABLE = 15,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_TYPE_DATE_TIME_FIELD = 16,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_TYPE_NULL = 17,
};
#endif /* ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_TYPE_ENUM */

#ifndef ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_MODE_ENUM
#define ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_MODE_ENUM
/**
 * @ingroup iface_zcr_extended_text_input_v1
 * Chrome's TextInputMode
 *
 * Similar to input_type defined above, this keeps Chrome's TextInputMode.
 * See TextInputMode's description for details for each entry.
 */
enum zcr_extended_text_input_v1_input_mode {
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_MODE_DEFAULT = 0,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_MODE_NONE = 1,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_MODE_TEXT = 2,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_MODE_TEL = 3,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_MODE_URL = 4,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_MODE_EMAIL = 5,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_MODE_NUMERIC = 6,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_MODE_DECIMAL = 7,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_MODE_SEARCH = 8,
};
#endif /* ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_MODE_ENUM */

#ifndef ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_FLAGS_ENUM
#define ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_FLAGS_ENUM
/**
 * @ingroup iface_zcr_extended_text_input_v1
 * Chrome's TextInputFlags
 *
 * Similar to input_type defined above, this keeps Chrome's TextInputFlags,
 * because content_hint is not enough power to represent what Chrome wants.
 * See TextInputFlags' description for details for each entry.
 */
enum zcr_extended_text_input_v1_input_flags {
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_FLAGS_NONE = 0,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_FLAGS_AUTOCOMPLETE_ON = 1 << 0,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_FLAGS_AUTOCOMPLETE_OFF = 1 << 1,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_FLAGS_AUTOCORRECT_ON = 1 << 2,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_FLAGS_AUTOCORRECT_OFF = 1 << 3,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_FLAGS_SPELLCHECK_ON = 1 << 4,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_FLAGS_SPELLCHECK_OFF = 1 << 5,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_FLAGS_AUTOCAPITALIZE_NONE = 1 << 6,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_FLAGS_AUTOCAPITALIZE_CHARACTERS = 1 << 7,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_FLAGS_AUTOCAPITALIZE_WORDS = 1 << 8,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_FLAGS_AUTOCAPITALIZE_SENTENCES = 1 << 9,
	ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_FLAGS_HAS_BEEN_PASSWORD = 1 << 10,
};
#endif /* ZCR_EXTENDED_TEXT_INPUT_V1_INPUT_FLAGS_ENUM */

#ifndef ZCR_EXTENDED_TEXT_INPUT_V1_LEARNING_MODE_ENUM
#define ZCR_EXTENDED_TEXT_INPUT_V1_LEARNING_MODE_ENUM
/**
 * @ingroup iface_zcr_extended_text_input_v1
 * Whether IME is allowed to learn
 */
enum zcr_extended_text_input_v1_learning_mode {
	ZCR_EXTENDED_TEXT_INPUT_V1_LEARNING_MODE_DISABLED = 0,
	ZCR_EXTENDED_TEXT_INPUT_V1_LEARNING_MODE_ENABLED = 1,
};
#endif /* ZCR_EXTENDED_TEXT_INPUT_V1_LEARNING_MODE_ENUM */

/**
 * @ingroup iface_zcr_extended_text_input_v1
 * @struct zcr_extended_text_input_v1_listener
 */
struct zcr_extended_text_input_v1_listener {
	/**
	 * set preedit from the surrounding text
	 *
	 * IME requests to update text_input client to set the preedit
	 * from the surrounding text.
	 *
	 * index is the starting point of the preedit, relative to the
	 * current cursor position in utf-8 byte-offset. length is the
	 * length of the preedit region in utf-8 byte length.
	 *
	 * Following the convention we have in text_input::preedit_string,
	 * text_input::preedit_styling sent just before this will be
	 * applied.
	 */
	void (*set_preedit_region)(void *data,
				   struct zcr_extended_text_input_v1 *zcr_extended_text_input_v1,
				   int32_t index,
				   uint32_t length);
	/**
	 * clear grammar fragments in a range
	 *
	 * IME requests to clear all the grammar markers within the given
	 * range defined by start and end.
	 *
	 * start and end are relative to the beginning of the input field
	 * in utf-8 byte length.
	 * @since 3
	 */
	void (*clear_grammar_fragments)(void *data,
					struct zcr_extended_text_input_v1 *zcr_extended_text_input_v1,
					uint32_t start,
					uint32_t end);
	/**
	 * add grammar fragment
	 *
	 * IME requests to add a new grammar fragment.
	 *
	 * A grammar fragment describes a range of text (start, end) that
	 * has grammar error and also gives the correct replacement text.
	 * It is expected that the renderer will render markers (e.g.
	 * squigles or dashed underlines) under the text to notify users
	 * that there is a grammar error. It is also expected that the
	 * renderer will maintain and update the position of fragment when
	 * users edit other parts of the text, e.g. if users type something
	 * before the grammar fragment, the marker should move accordingly.
	 *
	 * start and end are relative to the beginning of the input field
	 * in utf-8 byte length. suggestion is the correct replacement
	 * text, encoded in utf-8 and suggested by ML model.
	 * @since 3
	 */
	void (*add_grammar_fragment)(void *data,
				     struct zcr_extended_text_input_v1 *zcr_extended_text_input_v1,
				     uint32_t start,
				     uint32_t end,
				     const char *suggestion);
	/**
	 * set autocorrect range
	 *
	 * IME requests to update text_input client to set the
	 * autocorrect range. There is only one autocorrect range, so this
	 * replaces any existing autocorrect ranges.
	 *
	 * start and end are relative to the beginning of the input field
	 * in utf-8 byte length.
	 *
	 * If start and end are the same, then the autocorrect range is
	 * cleared.
	 * @since 4
	 */
	void (*set_autocorrect_range)(void *data,
				      struct zcr_extended_text_input_v1 *zcr_extended_text_input_v1,
				      uint32_t start,
				      uint32_t end);
};

/**
 * @ingroup iface_zcr_extended_text_input_v1
 */
static inline int
zcr_extended_text_input_v1_add_listener(struct zcr_extended_text_input_v1 *zcr_extended_text_input_v1,
					const struct zcr_extended_text_input_v1_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) zcr_extended_text_input_v1,
				     (void (**)(void)) listener, data);
}

#define ZCR_EXTENDED_TEXT_INPUT_V1_DESTROY 0
#define ZCR_EXTENDED_TEXT_INPUT_V1_SET_INPUT_TYPE 1
#define ZCR_EXTENDED_TEXT_INPUT_V1_SET_GRAMMAR_FRAGMENT_AT_CURSOR 2
#define ZCR_EXTENDED_TEXT_INPUT_V1_SET_AUTOCORRECT_INFO 3

/**
 * @ingroup iface_zcr_extended_text_input_v1
 */
#define ZCR_EXTENDED_TEXT_INPUT_V1_SET_PREEDIT_REGION_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_extended_text_input_v1
 */
#define ZCR_EXTENDED_TEXT_INPUT_V1_CLEAR_GRAMMAR_FRAGMENTS_SINCE_VERSION 3
/**
 * @ingroup iface_zcr_extended_text_input_v1
 */
#define ZCR_EXTENDED_TEXT_INPUT_V1_ADD_GRAMMAR_FRAGMENT_SINCE_VERSION 3
/**
 * @ingroup iface_zcr_extended_text_input_v1
 */
#define ZCR_EXTENDED_TEXT_INPUT_V1_SET_AUTOCORRECT_RANGE_SINCE_VERSION 4

/**
 * @ingroup iface_zcr_extended_text_input_v1
 */
#define ZCR_EXTENDED_TEXT_INPUT_V1_DESTROY_SINCE_VERSION 1
/**
 * @ingroup iface_zcr_extended_text_input_v1
 */
#define ZCR_EXTENDED_TEXT_INPUT_V1_SET_INPUT_TYPE_SINCE_VERSION 2
/**
 * @ingroup iface_zcr_extended_text_input_v1
 */
#define ZCR_EXTENDED_TEXT_INPUT_V1_SET_GRAMMAR_FRAGMENT_AT_CURSOR_SINCE_VERSION 3
/**
 * @ingroup iface_zcr_extended_text_input_v1
 */
#define ZCR_EXTENDED_TEXT_INPUT_V1_SET_AUTOCORRECT_INFO_SINCE_VERSION 4

/** @ingroup iface_zcr_extended_text_input_v1 */
static inline void
zcr_extended_text_input_v1_set_user_data(struct zcr_extended_text_input_v1 *zcr_extended_text_input_v1, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zcr_extended_text_input_v1, user_data);
}

/** @ingroup iface_zcr_extended_text_input_v1 */
static inline void *
zcr_extended_text_input_v1_get_user_data(struct zcr_extended_text_input_v1 *zcr_extended_text_input_v1)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zcr_extended_text_input_v1);
}

static inline uint32_t
zcr_extended_text_input_v1_get_version(struct zcr_extended_text_input_v1 *zcr_extended_text_input_v1)
{
	return wl_proxy_get_version((struct wl_proxy *) zcr_extended_text_input_v1);
}

/**
 * @ingroup iface_zcr_extended_text_input_v1
 */
static inline void
zcr_extended_text_input_v1_destroy(struct zcr_extended_text_input_v1 *zcr_extended_text_input_v1)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zcr_extended_text_input_v1,
			 ZCR_EXTENDED_TEXT_INPUT_V1_DESTROY, NULL, wl_proxy_get_version((struct wl_proxy *) zcr_extended_text_input_v1), WL_MARSHAL_FLAG_DESTROY);
}

/**
 * @ingroup iface_zcr_extended_text_input_v1
 *
 * In wayland, there's a concept that can be mapped to Chrome's
 * TextInputType, Mode and Flags. It can be set via
 * zwp_text_input::set_content_type. However, the variation is not rich
 * enough to represent Chrome's detailed behavior change. This API can be
 * used as a replacement of set_content_type.
 */
static inline void
zcr_extended_text_input_v1_set_input_type(struct zcr_extended_text_input_v1 *zcr_extended_text_input_v1, uint32_t input_type, uint32_t input_mode, uint32_t input_flags, uint32_t learning_mode)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zcr_extended_text_input_v1,
			 ZCR_EXTENDED_TEXT_INPUT_V1_SET_INPUT_TYPE, NULL, wl_proxy_get_version((struct wl_proxy *) zcr_extended_text_input_v1), 0, input_type, input_mode, input_flags, learning_mode);
}

/**
 * @ingroup iface_zcr_extended_text_input_v1
 *
 * Informs the IME of the grammar fragment containing the current cursor.
 * If not existing, both start and end are set to 0. This is called
 * whenever the cursor position or surrounding text have changed.
 *
 * start and end are relative to the beginning of the input field in
 * utf-8 byte length. suggestion is the correct replacement text encoded
 * in utf-8 and suggested by ML model.
 */
static inline void
zcr_extended_text_input_v1_set_grammar_fragment_at_cursor(struct zcr_extended_text_input_v1 *zcr_extended_text_input_v1, uint32_t start, uint32_t end, const char *suggestion)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zcr_extended_text_input_v1,
			 ZCR_EXTENDED_TEXT_INPUT_V1_SET_GRAMMAR_FRAGMENT_AT_CURSOR, NULL, wl_proxy_get_version((struct wl_proxy *) zcr_extended_text_input_v1), 0, start, end, suggestion);
}

/**
 * @ingroup iface_zcr_extended_text_input_v1
 *
 * Informs the IME the range and bounds of the current autocorrect change.
 * This is called whenever the range or bounds have changed.
 *
 * start and end are relative to the beginning of the input field in utf-8
 * byte length.
 *
 * x, y, width, and height are the bounds of the autocorrect text, relative
 * to the window.
 *
 * This request only changes a pending state that will be effective on the
 * next 'set_surrounding_text' request.
 */
static inline void
zcr_extended_text_input_v1_set_autocorrect_info(struct zcr_extended_text_input_v1 *zcr_extended_text_input_v1, uint32_t start, uint32_t end, uint32_t x, uint32_t y, uint32_t width, uint32_t height)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zcr_extended_text_input_v1,
			 ZCR_EXTENDED_TEXT_INPUT_V1_SET_AUTOCORRECT_INFO, NULL, wl_proxy_get_version((struct wl_proxy *) zcr_extended_text_input_v1), 0, start, end, x, y, width, height);
}

#ifdef  __cplusplus
}
#endif

#endif
